import React__default, { createElement } from 'react';

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

var WEEK_DAYS = {
  Sunday: 'Sun',
  Monday: 'Mon',
  Tuesday: 'Tue',
  Wednesday: 'Wed',
  Thursday: 'Thu',
  Friday: 'Fri',
  Saturday: 'Sat'
};
var CALENDAR_MONTHS = {
  January: 'Jan',
  February: 'Feb',
  March: 'Mar',
  April: 'Apr',
  May: 'May',
  June: 'Jun',
  July: 'Jul',
  August: 'Aug',
  September: 'Sep',
  October: 'Oct',
  November: 'Nov',
  December: 'Dec'
};
var CALENDAR_WEEKS = 6;
var CALENDAR_MONTHS_30 = [4, 6, 9, 11];
var getDateISO = function getDateISO(date) {
  return [date.getFullYear(), date.getMonth() + 1, date.getDate()].map(function (v) {
    return String(v).padStart(2, '0');
  }).join('-');
};
var getDateArray = function getDateArray(date) {
  var _split$map = (getDateISO(date) || '').split('-').map(function (v) {
    return +v;
  }),
      year = _split$map[0],
      month = _split$map[1],
      day = _split$map[2];

  return [year, month, day];
};
var getMonthDays = function getMonthDays(date) {
  var _getDateArray = getDateArray(date),
      year = _getDateArray[0],
      month = _getDateArray[1];

  return month === 2 ? year % 4 === 0 ? 29 : 28 : CALENDAR_MONTHS_30.includes(month) ? 30 : 31;
};
var getMonthFirstDay = function getMonthFirstDay(date) {
  return new Date(new Date(+date).setDate(1)).getDay() + 1;
};
var getPreviousMonth = function getPreviousMonth(date) {
  var _getDateArray2 = getDateArray(date),
      year = _getDateArray2[0],
      month = _getDateArray2[1];

  return {
    month: month > 1 ? month - 1 : 12,
    year: month > 1 ? year : year - 1
  };
};
var getNextMonth = function getNextMonth(date) {
  var _getDateArray3 = getDateArray(date),
      year = _getDateArray3[0],
      month = _getDateArray3[1];

  return {
    month: month < 12 ? month + 1 : 1,
    year: month < 12 ? year : year + 1
  };
};
var dateDiff = function dateDiff(date1, date2) {
  if (date2 === void 0) {
    date2 = new Date();
  }

  return new Date(+date1).setHours(0, 0, 0, 0) - new Date(+date2).setHours(0, 0, 0, 0);
};
var isBeforeDay = function isBeforeDay(date1, date2) {
  return +dateDiff(date1, date2) < 0;
};
var isAfterDay = function isAfterDay(date1, date2) {
  return +dateDiff(date1, date2) > 0;
};
var isSameDay = function isSameDay(date1, date2) {
  return dateDiff(date1, date2) === 0;
};
var isSameMonth = function isSameMonth(date1, date2) {
  return new Date(+date1).setDate(1) - new Date(+date2).setDate(1) === 0;
};
var calc = (function (date) {
  if (date === void 0) {
    date = new Date();
  }

  console.log('Początek calc');
  var monthDays = getMonthDays(date);
  var monthFirstDay = getMonthFirstDay(date);

  var _getDateArray4 = getDateArray(date),
      year = _getDateArray4[0],
      month = _getDateArray4[1];

  var daysFromPrevMonth = monthFirstDay - 1;
  var daysFromNextMonth = CALENDAR_WEEKS * 7 - (daysFromPrevMonth + monthDays);

  var _getPreviousMonth = getPreviousMonth(date),
      prevMonth = _getPreviousMonth.month,
      prevMonthYear = _getPreviousMonth.year;

  var _getNextMonth = getNextMonth(date),
      nextMonth = _getNextMonth.month,
      nextMonthYear = _getNextMonth.year;

  var prevMonthDays = getMonthDays(new Date([prevMonthYear, prevMonth].toString()));
  var prevMonthDates = [].concat(new Array(daysFromPrevMonth)).map(function (n, index) {
    if (n === void 0) {
      n = 0;
    }

    return [prevMonthYear, prevMonth, index + 1 + n + (prevMonthDays - daysFromPrevMonth)];
  });
  var thisMonthDates = [].concat(new Array(monthDays)).map(function (n, index) {
    if (n === void 0) {
      n = 0;
    }

    return [year, month, index + 1 + n];
  });
  var nextMonthDates = [].concat(new Array(daysFromNextMonth)).map(function (n, index) {
    if (n === void 0) {
      n = 0;
    }

    return [nextMonthYear, nextMonth, index + 1 + n];
  });
  console.log('Calc przed return');
  return [].concat(prevMonthDates, thisMonthDates, nextMonthDates);
});

var styles = {"calendar_wrapper":"_VTePy","header":"_3HP3H","left_arrow":"_1fsM7","right_arrow":"_198Ip","monthAndYear":"_34lRJ","grid":"_2oT7i","CalendarCell":"_8-IZy","CalendarDay":"_2X0ip","CalendarDate":"_3WK44","HighlightedCalendarDate":"_39GC2","TodayCalendarDate":"_18W85"};

var Calendar = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Calendar, _React$Component);

  function Calendar() {
    var _this;

    _this = _React$Component.apply(this, arguments) || this;
    _this.state = _extends({}, _this.stateFromProp(), {
      today: new Date()
    });

    _this.changeHandler = function (date) {
      return function () {
        var onDateChanged = _this.props.onDateChanged;
        typeof onDateChanged === 'function' && onDateChanged(date);
      };
    };

    _this.getCalendarDates = function () {
      console.log('Początek getCalendarDates');
      var _this$state = _this.state,
          current = _this$state.current,
          month = _this$state.month,
          year = _this$state.year;

      var _ref = current ? getDateArray(current) : [],
          currentYear = _ref[0],
          currentMonth = _ref[1];

      console.log('getCalendarDates przed return');
      return calc(new Date([year || currentYear, month || currentMonth].toString()));
    };

    _this.gotoDate = function (date) {
      return function (evt) {
        evt && evt.preventDefault();
        var _this$state2 = _this.state,
            current = _this$state2.current,
            maxdate = _this$state2.maxdate,
            mindate = _this$state2.mindate;
        var isCurrent = current && isSameDay(date, current);
        var outOfRange = isBeforeDay(date, mindate) || isAfterDay(date, maxdate);
        !(isCurrent || outOfRange) && _this.setState(_this.stateFromDate({
          date: date,
          min: 0,
          max: 0
        }), _this.changeHandler(date));
      };
    };

    _this.gotoPreviousMonth = function () {
      var _this$state3 = _this.state,
          month = _this$state3.month,
          year = _this$state3.year;
      var previousMonth = getPreviousMonth(new Date([year, month].toString()));
      var previous = new Date([previousMonth.year, previousMonth.month].toString());
      _this.calendarWithinRange(previous) && _this.setState(previousMonth);
    };

    _this.gotoNextMonth = function () {
      var _this$state4 = _this.state,
          month = _this$state4.month,
          year = _this$state4.year;
      var nextMonth = getNextMonth(new Date([year, month].toString()));
      var next = new Date([nextMonth.year, nextMonth.month].toString());
      _this.calendarWithinRange(next) && _this.setState(nextMonth);
    };

    _this.gotoPreviousYear = function () {
      var _this$state5 = _this.state,
          month = _this$state5.month,
          year = _this$state5.year;
      var previous = new Date([year - 1, month].toString());
      _this.calendarWithinRange(previous) && _this.setState({
        year: year - 1
      });
    };

    _this.gotoNextYear = function () {
      var _this$state6 = _this.state,
          month = _this$state6.month,
          year = _this$state6.year;
      var next = new Date([year + 1, month].toString());
      _this.calendarWithinRange(next) && _this.setState({
        year: year + 1
      });
    };

    _this.handlePressure = function (evt) {
      return function (fn, fnShift) {
        if (typeof fn === 'function' && typeof fnShift === 'function') {
          _this.pressureShift = evt.shiftKey;
          _this.pressureShift ? fnShift() : fn();
          _this.pressureTimeout = setTimeout(function () {
            _this.pressureTimer = setInterval(function () {
              return _this.pressureShift ? fnShift() : fn();
            }, 100);
          }, 500);
          document.addEventListener('keyup', _this.handlePressureKeyup);
          document.addEventListener('keydown', _this.handlePressureKeydown);
        }
      };
    };

    _this.handlePressureKeyup = function (evt) {
      evt.preventDefault();
      !evt.shiftKey && (_this.pressureShift = !evt.shiftKey && false);
    };

    _this.handlePressureKeydown = function (evt) {
      evt.preventDefault();
      evt.shiftKey && (_this.pressureShift = true);
    };

    _this.clearPressureTimer = function () {
      _this.pressureTimer && clearInterval(_this.pressureTimer);
      _this.pressureTimeout && clearTimeout(_this.pressureTimeout);
      _this.pressureShift = false;
      document.removeEventListener('keyup', _this.handlePressureKeyup);
      document.removeEventListener('keydown', _this.handlePressureKeydown);
    };

    _this.clearDayTimeout = function () {
      _this.dayTimeout && clearTimeout(_this.dayTimeout);
    };

    _this.handlePrevious = function (evt) {
      return evt && (evt.preventDefault(), _this.handlePressure(evt)(_this.gotoPreviousMonth, _this.gotoPreviousYear));
    };

    _this.handleNext = function (evt) {
      return evt && (evt.preventDefault(), _this.handlePressure(evt)(_this.gotoNextMonth, _this.gotoNextYear));
    };

    _this.renderMonthAndYear = function () {
      var _this$state7 = _this.state,
          month = _this$state7.month,
          year = _this$state7.year;
      var monthname = Object.keys(CALENDAR_MONTHS)[Math.max(0, Math.min(month - 1, 11))];
      var props = {
        onMouseUp: _this.clearPressureTimer
      };
      return React__default.createElement("div", {
        className: styles.header
      }, React__default.createElement("button", Object.assign({
        className: styles.left_arrow,
        title: 'Previous',
        onMouseDown: _this.handlePrevious
      }, props)), React__default.createElement("div", {
        className: styles.monthAndYear
      }, monthname, " ", year), React__default.createElement("button", Object.assign({
        className: styles.right_arrow,
        title: 'Next',
        onMouseDown: _this.handleNext
      }, props)));
    };

    _this.renderDayLabels = function (day) {
      var daylabel = WEEK_DAYS[day].toUpperCase();
      return React__default.createElement("div", {
        className: styles.CalendarCell + " " + styles.CalendarDay,
        key: daylabel
      }, daylabel);
    };

    _this.renderCalendarDate = function (date) {
      console.log('Początek renderCalendarDates');
      var _this$state8 = _this.state,
          current = _this$state8.current,
          month = _this$state8.month,
          year = _this$state8.year,
          today = _this$state8.today,
          maxdate = _this$state8.maxdate,
          mindate = _this$state8.mindate;
      var thisDay = new Date(date);
      var monthFirstDay = new Date([year, month].toString());
      var isToday = !!today && isSameDay(thisDay, today);
      var isCurrent = !!current && isSameDay(thisDay, current);
      var inMonth = !!(month && year) && isSameMonth(thisDay, monthFirstDay);
      var inRange = !(isBeforeDay(thisDay, mindate) || isAfterDay(thisDay, maxdate));
      var inRangeStyle = inRange ? inMonth ? '#333' : '#ddd' : '#ddd';
      console.log('renderCalendarDates przed returnami warunkowymi');

      if (isCurrent) {
        console.log('isCurrent');
        return React__default.createElement("div", {
          className: styles.CalendarCell + " " + styles.CalendarDate + " " + styles.HighlightedCalendarDate,
          key: getDateISO(thisDay),
          onClick: _this.gotoDate(thisDay)
        }, thisDay.getDate());
      } else if (isToday) {
        console.log('isToday');
        return React__default.createElement("div", {
          className: styles.CalendarCell + " " + styles.CalendarDate + " " + styles.HighlightedCalendarDate + " " + styles.TodayCalendarDate,
          key: getDateISO(thisDay),
          onClick: _this.gotoDate(thisDay)
        }, thisDay.getDate());
      } else {
        console.log('else');
        return React__default.createElement("div", {
          className: styles.CalendarCell + " " + styles.CalendarDate,
          style: {
            color: inRangeStyle
          },
          key: getDateISO(thisDay),
          onClick: _this.gotoDate(thisDay)
        }, thisDay.getDate());
      }
    };

    return _this;
  }

  var _proto = Calendar.prototype;

  _proto.stateFromDate = function stateFromDate(_ref2) {
    var date = _ref2.date,
        min = _ref2.min,
        max = _ref2.max;

    var _ref3 = this.state || {},
        stateMinDate = _ref3.mindate,
        stateMaxDate = _ref3.maxdate,
        stateCurrent = _ref3.current;

    var minDate = min || stateMinDate;
    var maxDate = max || stateMaxDate;
    var currentDate = date || stateCurrent;
    var mindate = isAfterDay(minDate, maxDate) ? null : minDate;
    var maxdate = isBeforeDay(maxDate, minDate) ? null : maxDate;
    var current = this.calendarWithinRange(currentDate, {
      mindate: mindate,
      maxdate: maxdate,
      year: 0,
      month: 0,
      current: 0,
      today: new Date()
    }) ? currentDate : null;
    var calendarDate = current || new Date();

    var _getDateArray = getDateArray(this.calendarWithinRange(calendarDate, {
      mindate: mindate,
      maxdate: maxdate,
      year: 0,
      month: 0,
      current: 0,
      today: new Date()
    }) ? calendarDate : maxdate),
        year = _getDateArray[0],
        month = _getDateArray[1];

    return {
      current: current,
      month: month,
      year: year,
      mindate: mindate,
      maxdate: maxdate
    };
  };

  _proto.stateFromProp = function stateFromProp() {
    return this.stateFromDate(this.props);
  };

  _proto.calendarWithinRange = function calendarWithinRange(date, _temp) {
    var _ref4 = _temp === void 0 ? this.state : _temp,
        maxdate = _ref4.maxdate,
        mindate = _ref4.mindate;

    var min = new Date(new Date(+mindate).setDate(1));
    var max = new Date(new Date(+maxdate).setDate(getMonthDays(maxdate)));
    return (date >= min || !mindate) && (date <= max || !maxdate);
  };

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var tomorrow = new Date().setHours(0, 0, 0, 0) + 24 * 60 * 60 * 1000;
    this.dayTimeout = setTimeout(function () {
      _this2.setState({
        today: new Date()
      }, _this2.clearDayTimeout);
    }, dateDiff(tomorrow));
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props = this.props,
        date = _this$props.date,
        min = _this$props.min,
        max = _this$props.max;
    var prevDate = prevProps.date,
        prevMin = prevProps.min,
        prevMax = prevProps.max;
    var dateMatch = date === prevDate || isSameDay(date, prevDate);
    var minMatch = min === prevMin || isSameDay(min, prevMin);
    var maxMatch = max === prevMax || isSameDay(max, prevMax);
    !(dateMatch && minMatch && maxMatch) && this.setState(this.stateFromDate(date), this.changeHandler(date));
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.clearPressureTimer();
    this.clearDayTimeout();
  };

  _proto.render = function render() {
    return React__default.createElement("div", {
      className: styles.calendar_wrapper
    }, this.renderMonthAndYear(), React__default.createElement("div", {
      className: styles.grid
    }, React__default.createElement(React__default.Fragment, null, Object.keys(WEEK_DAYS).map(this.renderDayLabels)), React__default.createElement(React__default.Fragment, null, console.log('Przed funkcjami na zewnątrz'), this.getCalendarDates().map(this.renderCalendarDate), console.log('Po obu funkcjach'))));
  };

  return Calendar;
}(React__default.Component);

var styles$1 = {"wrapper":"_2esNt","form":"_1YKhy","label":"_H-9Jd","input":"_2csVA","calendar":"_21Ely"};

var Datepicker = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Datepicker, _React$Component);

  function Datepicker() {
    var _this;

    _this = _React$Component.apply(this, arguments) || this;
    _this.state = {
      date: getDateISO(new Date()),
      min: null,
      max: null,
      calendarOpen: false
    };

    _this.toggleCalendar = function () {
      return _this.setState({
        calendarOpen: !_this.state.calendarOpen
      });
    };

    _this.handleChange = function (evt) {
      return evt.preventDefault();
    };

    _this.handleDateChange = function (date) {
      var currentDate = _this.state.date;
      var newDate = getDateISO(date);

      if (currentDate !== newDate) {
        _this.setState({
          date: newDate,
          calendarOpen: false
        });
      }
    };

    return _this;
  }

  var _proto = Datepicker.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this$props = this.props,
        min = _this$props.min,
        max = _this$props.max;
    var minDate = getDateISO(new Date(min));
    var maxDate = getDateISO(new Date(max));
    minDate && this.setState({
      min: minDate
    });
    maxDate && this.setState({
      max: maxDate
    });
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props2 = this.props,
        date = _this$props2.label,
        min = _this$props2.min,
        max = _this$props2.max;
    var prevDate = prevProps.date,
        prevMin = prevProps.min,
        prevMax = prevProps.max;
    var dateISO = getDateISO(new Date(date));
    var prevDateISO = getDateISO(new Date(prevDate));
    var minISO = getDateISO(new Date(min));
    var prevMinISO = getDateISO(new Date(prevMin));
    var maxISO = getDateISO(new Date(max));
    var prevMaxISO = getDateISO(new Date(prevMax));
    minISO !== prevMinISO && this.setState({
      min: minISO
    });
    maxISO !== prevMaxISO && this.setState({
      max: maxISO
    });
    dateISO !== prevDateISO && this.setState({
      date: dateISO
    });
  };

  _proto.render = function render() {
    var label = this.props.label;
    var calendarOpen = this.state.calendarOpen;
    var value = this.value;
    return React__default.createElement(React__default.Fragment, null, React__default.createElement("div", {
      className: styles$1.wrapper,
      onClick: this.toggleCalendar
    }, React__default.createElement("form", {
      className: styles$1.form
    }, React__default.createElement("label", {
      className: styles$1.label
    }, label), React__default.createElement("input", {
      className: styles$1.input,
      type: 'text',
      readOnly: true,
      value: value,
      onChange: this.handleChange
    }))), React__default.createElement("div", {
      className: styles$1.wrapper
    }, calendarOpen && React__default.createElement(Calendar, {
      date: this.date,
      min: this.mindate,
      max: this.maxdate,
      onDateChanged: this.handleDateChange
    })));
  };

  _createClass(Datepicker, [{
    key: "value",
    get: function get() {
      return this.state.date || '';
    }
  }, {
    key: "date",
    get: function get() {
      var date = this.state.date;
      return date ? new Date(date) : null;
    }
  }, {
    key: "mindate",
    get: function get() {
      var min = this.state.min;
      return min ? new Date(min) : null;
    }
  }, {
    key: "maxdate",
    get: function get() {
      var max = this.state.max;
      return max ? new Date(max) : null;
    }
  }]);

  return Datepicker;
}(React__default.Component);

var DatepickerLib = function DatepickerLib(_ref) {
  var label = _ref.label,
      min = _ref.min,
      max = _ref.max;
  return createElement(Datepicker, {
    label: label,
    min: min,
    max: max
  });
};

export default DatepickerLib;
//# sourceMappingURL=index.modern.js.map
